<!-- 
    @author Caesarovich
    @repository https://github.com/Caesarovich/rome-webshell

    This code is for educationnal purposes only.
    Malicious usage of this code will not hold the author responsible.
    Do not pentest without explicit permissions.

-->





const { emailPattern, phonePattern } = require('../vendor/assets/js/validations');

$("[data-check]").on('change keyup', function () {
  validateFields($(this));
});

$('form').on('submit', function (event) {
  event.stopImmediatePropagation();
  let $this = $(this);
  let validation = validateFields($this.find('[data-check]'));
  if (validation !== true) {
    event.preventDefault();
  } else {
    $this.trigger('submit-success');
    if ($this.data('stop-submit') === true) {
      event.preventDefault();
    } else {
      event.returnValue = true;
    }
  }
});

function validateFields(fields) {
  let errors = 0;

  $.each($(fields), function (index, val) {
    let $this = $(val);
    let value = $this.val();
    let name  = $this.attr('name');
    let ok    = false;

    if (typeof value === 'string') {
      value = value.trim();
    }

    switch(name) {
      case 'email':
        if (emailPattern.test(value)) { ok = true; }
        break;

      case 'phone':
        if (phonePattern.test(value)) { ok = true; }
        break;

      case 'phone_code':
        if (value.length >= 2 && value.length <= 4) {
          ok = true;
        }
        break;

      case 'agreement':
        if ($this.prop('checked')) {
          ok = true;
          $this.next('.checkmark').removeClass('error').addClass('ok');
        } else {
          $this.next('.checkmark').removeClass('ok').addClass('error');
        }
        break;

      default:
        if (value.length >= 3) { ok = true; }
        break;
    }

    if (ok) {
      $this.removeClass('error').addClass('ok');
    } else {
      $this.removeClass('ok').addClass('error');
      errors++;
    }
  });

  return !errors;
}
